#!/usr/bin/perl -w
# Copyright (C) 2007 by Oleksandr Tymoshenko. All rights reserved.

use strict;
use Getopt::Std;
use File::Basename;

sub copy 
{
	my ($from, $to) = @_;
	my ($file) = fileparse($from);
	system ("/bin/cp $from $to");
}

sub read_file
{
	my $f = shift;
	local $/ = undef;
	open F, "< $f" or die("\nCan't open file $f: $!");
	my $data = <F>;
	close F;

	return $data;
}

# Get arguments
my %opts;
getopt("sd", \%opts);

# OK, just a dumb script to make porter's life less miserable
my $zaptel_base = $opts{s} || "/home/gonzo/src/zaptel/1.4.11";
my $zaptel_dest = $opts{d} || "/home/gonzo/projects/zaptel-bsd-ng/";

my @packages = qw(wct4xxp);
print STDERR "Linux sources: $zaptel_base\n";
print STDERR "zaptel-bsd sources: $zaptel_dest\n";
foreach my $pkg (@packages) {
	print STDERR "Processing $pkg:\n";
	require "$pkg.pm";
	my $files_to_beastify = eval("\\%${pkg}::files_to_beastify");
	my $files_to_copy = eval("\\%${pkg}::files_to_copy");

	foreach my $file (keys %{$files_to_beastify}) {
		my $dst = $files_to_beastify->{$file}->{dst};
		print STDERR "  [B] $file to $dst ...";
		my $filter = $files_to_beastify->{$file}->{filter};
		my $source = read_file("$zaptel_base/$file");
		$source = $filter->($source);
		open F, "> $zaptel_dest/$dst";
		print F $source;
		close F;

		print STDERR "done\n";
	}

	foreach my $file (keys %{$files_to_copy}) {
		my $dst = $files_to_copy->{$file};
		print STDERR "  [C] $file to $dst ...";
		copy ("$zaptel_base/$file", "$zaptel_dest/$dst");
		print STDERR "done\n";
	}
}
