package wctdm;
use Beastify;

our (%files_to_copy, %files_to_beastify);

my $includes = <<__EOF__;
#include <sys/param.h>  /* defines used in kernel.h */
#include <sys/module.h>
#include <sys/systm.h>
#include <sys/errno.h>
#include <sys/kernel.h> /* types used in module initialization */
#include <sys/conf.h>   /* cdevsw struct */
#include <sys/uio.h>    /* uio struct */
#include <sys/malloc.h>
#include <sys/lock.h>
#include <sys/endian.h>
#include <sys/bus.h>  /* structs, prototypes for pci bus stuff */

#include <machine/bus.h>
#include <sys/rman.h>
#include <machine/resource.h>
#include <machine/clock.h>
#include <sys/sysctl.h>

#include <dev/pci/pcireg.h>
#include <dev/pci/pcivar.h>

MALLOC_DEFINE(M_WCTDM, "wctdm", "wctdm hw data structures");
__EOF__

sub fixup_src
{
	my $src = shift;

	$src =~ s/static char \*opermode/static char opermode[128]/;
	$src = Beastify::port_locks($src);
	$src = Beastify::port_printk($src);
	$src = Beastify::port_errno($src);
	$src =~ s@#include\s+<linux/kernel.h>.*#include "proslic.h"@$includes#include "proslic.h"@s;
	$src =~ s@([\t ]+)unsigned long ioaddr;.*?volatile unsigned int \*readchunk;[^\n]*@$1struct zt_io_t wc_io;\n$1struct zt_dma_t wc_dma;\n$1struct zt_irq_t wc_irq;@s;
	$src = Beastify::port_module_generics($src);
	$src = Beastify::port_ioctl($src);
	$src =~ s/([ \t]+)#define MAX (\d+)/$1#undef MAX\n$1#define MAX $2/;

	# Delay
	$src =~ s/([^\n]+)set_current_state.*schedule_timeout[^\n]+/$1tsleep(wc, PZERO | PCATCH, "startdma", 1);/gs;
	$src = Beastify::cleanout_moduleinfo($src);
	$src = Beastify::port_tunables($src, "zaptel.wctdm");

	$src = Beastify::port_types($src);
	$src = Beastify::port_interrupt_code($src);
	$src = Beastify::port_kmemory($src, "M_WCTDM");
	$src = Beastify::generate_module_wrapper($src, "wctdm", "wctdm", "wctdm");

	return $src;
}

sub fixup_includes
{
	my $src = shift;

	$src =~ s@linux/ioctl.h@sys/ioccom.h@;

	return $src;
}

# {{{ Files to port for wctdm package
%files_to_copy = ();

%files_to_beastify = (
	"kernel/wctdm.c" => {
		filter => \&fixup_src,
		dst => "wctdm/wctdm.c",
	},
	"kernel/wctdm.h" => {
		filter => \&fixup_includes,
		dst => "wctdm/wctdm.h",
	},
); 
# }}}

1;
