#ifndef _WCT4XXP_H
#define _WCT4XXP_H

/* Locking stuff */
#ifdef __FreeBSD__
#	if __FreeBSD_version < 500000
#		define lock_t	struct lock
#		define WCT4_LOCK(_lock) simple_lock(&(_lock))
#		define WCT4_UNLOCK(_lock) simple_unlock(&(_lock))
#		define WCT4_LOCK_INIT(_lock, name) simple_lock_init(&(_lock))
#		define WCT4_LOCK_DESTROY(_lock) do{}while(0)
	/* lockmgr locks */
#		define	WCT4_MGR_LOCK(_lock, flags) lockmgr(&(_lock), \
			flags, 0, curproc)
#		define	WCT4_MGR_DESTROY_LOCK(_lock) do{}while(0)
#	else
#		define lock_t	struct mtx
#		define WCT4_LOCK(_lock)           	mtx_lock_spin(&(_lock))
#		define WCT4_UNLOCK(_lock)         	mtx_unlock_spin(&(_lock))
#		define WCT4_LOCK_INIT(_lock, name)	mtx_init(&(_lock), \
							name, "wct4_lock", MTX_SPIN)
#		define WCT4_LOCK_DESTROY(_lock)		mtx_destroy(&(_lock))
#	endif
#else /* 0 */
#		define WCT4_LOCK(_lock) 
#		define WCT4_UNLOCK(_lock) 
#		define WCT4_LOCK_INIT(_lock, name) 
#		define WCT4_LOCK_DESTROY(_lock) 
#endif

struct wct4xxp_dmadata {
	unsigned int	*wc_writechunk;
	unsigned int	*wc_readchunk;

	bus_addr_t	wc_read_dmaaddr;
	bus_addr_t	wc_write_dmaaddr;

	bus_dma_tag_t	wc_dma_tag;
	bus_dmamap_t	wc_dma_map;
};

#endif
